import sys
from os import environ
from os import getcwd
import string
from PySteppablesExamples import SimulationFileStorage

sys.path.append(environ["PYTHON_MODULE_PATH"])


import CompuCellSetup

sim,simthread = CompuCellSetup.getCoreSimulationObjects()

#Create extra player fields here or add attributes
pyAttributeAdder,listAdder=CompuCellSetup.attachDictionaryToCells(sim)

#Create extra player fields here or add attributes
rhoField=simthread.createScalarFieldCellLevelPy("RhoField") 

CompuCellSetup.initializeSimulationObjects(sim,simthread)

#Add Python steppables here
steppableRegistry=CompuCellSetup.getSteppableRegistry()

from Heiko3_O2_ps_Steppables import CellGrowth
cellGrowthSteppable=CellGrowth(_simulator=sim,_frequency=10)
steppableRegistry.registerSteppable(cellGrowthSteppable)

from Heiko3_O2_ps_Steppables import MitosisSteppable
mitosisSteppable=MitosisSteppable(_simulator=sim,_frequency=1)
steppableRegistry.registerSteppable(mitosisSteppable)

from Heiko3_O2_ps_Steppables import *
rhoFieldVisualizationSteppable=RhoFieldVisualizationSteppable(_simulator=sim,_frequency=1)
rhoFieldVisualizationSteppable.setScalarField(rhoField)
steppableRegistry.registerSteppable(rhoFieldVisualizationSteppable)


CompuCellSetup.mainLoop(sim,simthread,steppableRegistry)

