from PySteppables import *
from PySteppablesExamples import MitosisSteppableBase
from random import *
import CompuCell
import sys
from PlayerPython import *
from math import *

ps=0.33
rho=10
lVSC=100
lVCC=50

class CellGrowth(SteppableBasePy):
    def __init__(self,_simulator,_frequency=1):
        SteppableBasePy.__init__(self,_simulator,_frequency)


    def start(self):
        print "This function is called once before simulation"
        for cell in self.cellList:
            cell.type=2 #type 2 is a stem cell
        for cell in self.cellList:
            cell.targetVolume=25
            cell.lambdaVolume=lVSC
        for cell in self.cellList:
            list_dict=CompuCell.getPyAttrib(cell)
            list_dict["Counter"]=rho
            list_dict["StemFraction"]=ps
    def step(self,mcs):
        print "This function is called every 10 MCS"
        for cell in self.cellList:
            cell.targetVolume+=1  

           
class MitosisSteppable(MitosisSteppableBase):
    def __init__(self,_simulator,_frequency=1):
        MitosisSteppableBase.__init__(self,_simulator, _frequency)
    
    def step(self,mcs):
        cells_to_divide=[]
        
        for cell in self.cellList:
            if cell.volume>50:
                cells_to_divide.append(cell)
               
        for cell in cells_to_divide:
            self.divideCellRandomOrientation(cell)
            
    def updateAttributes(self):
        parentCell=self.mitosisSteppable.parentCell
        parentDict=CompuCell.getPyAttrib(parentCell)
        parentCell.targetVolume=25
        if parentCell.type==1:
            parentCell.lambdaVolume=lVCC
        else:
            parentCell.lambdaVolume=lVSC
            
        if parentCell.type==1: # decrement counter if cell type == 1, i.e. CC
            parentDict["Counter"]-=1
        if parentDict["Counter"]<=0:
            parentCell.targetVolume=0

        childCell=self.mitosisSteppable.childCell
        childDict=CompuCell.getPyAttrib(childCell)
        childCell.targetVolume=25
        if childCell.type==1:
            childCell.lambdaVolume=lVCC
        else:
            childCell.lambdaVolume=lVSC

        # set the child cell type
        childCell.type=1  # set child default type to CC 
        #unless parent is stem cell undergoing symmetric divison with ps
        if parentCell.type==2: 
            if (random()<ps):
                childCell.type=2

        childDict["Counter"]=parentDict["Counter"]
        childDict["StemFraction"]=parentDict["StemFraction"]
        
        #check if child cell counter needs decrementing; only if parent is stem and child is not
        if parentCell.type==2:
            if childCell.type==1:
                childDict["Counter"]-=1
        if childDict["Counter"]<=0:
            childCell.targetVolume=0
                
        #random chance of swapping identities of parent and child
        if (random()<0.5):       
            tempCounter=parentDict["Counter"]
            parentDict["Counter"]=childDict["Counter"]
            childDict["Counter"]=tempCounter
			
            tempCounter=parentDict["StemFraction"]
            parentDict["StemFraction"]=childDict["StemFraction"]
            childDict["StemFraction"]=tempCounter
			
            tempType=parentCell.type
            parentCell.type=childCell.type
            childCell.type=tempType
    


class RhoFieldVisualizationSteppable(SteppableBasePy):
    def __init__(self,_simulator,_frequency=10):
        SteppableBasePy.__init__(self,_simulator,_frequency)

    def setScalarField(self,_field):
        self.scalarField=_field

    def step(self,mcs):
        clearScalarValueCellLevel(self.scalarField)
        from random import random
        for cell in self.cellList:
            cellDict=CompuCell.getPyAttrib(cell)
            fillScalarValueCellLevel(self.scalarField,cell,cellDict["Counter"])
